commit 611ca2dfc78b5e354cc4dfe3fa6f2c0c780bd78e
Author: freddy77 <freddy77>
Date:   Sat Oct 3 09:19:27 2009 +0000

    unprepare optimization for emulated dynamics

diff --git a/ChangeLog b/ChangeLog
index b2f4998..772ca30 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Oct  3 11:19:20 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: unprepare optimization for emulated dynamics
+
 Fri Oct  2 11:23:18 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/ct.c src/tds/query.c src/tds/tds_checks.c:
 	- Support RPCs using tds 4.2
@@ -1864,4 +1867,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2876 2009/10/02 09:24:07 freddy77 Exp $
+$Id: ChangeLog,v 1.2877 2009/10/03 09:19:27 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 4c55639..9ec674f 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.513 2009/08/20 15:14:19 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.514 2009/10/03 09:19:27 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -6853,7 +6853,10 @@ odbc_free_dynamic(TDS_STMT * stmt)
 	TDSSOCKET *tds = stmt->dbc->tds_socket;
 
 	if (stmt->dyn) {
-		if (tds_submit_unprepare(tds, stmt->dyn) == TDS_SUCCEED) {
+		if (stmt->dyn->emulated) {
+			tds_free_dynamic(tds, stmt->dyn);
+			stmt->dyn = NULL;
+		} else if (tds_submit_unprepare(tds, stmt->dyn) == TDS_SUCCEED) {
 			if (tds_process_simple_query(tds) != TDS_SUCCEED)
 				ODBC_RETURN(stmt, SQL_ERROR);
 			tds_free_dynamic(tds, stmt->dyn);

